package Utopp.Komponenten;
import java.util.Vector;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:
 * @author
 * @version 1.0
 */

public class UmlKlasse extends UmlKomponente implements java.io.Serializable{
String packet;
Vector methoden = new Vector();
Vector attribute = new Vector();
String zusicherung;
String stereotyp;
boolean abstrakt;
int visibility;

  public UmlKlasse() {}
  public UmlKlasse(String inname) {
    super.name = inname;
  }
  public UmlKlasse(String inname,String pack, Vector met, Vector att, String zu, String stereo, boolean abst, int vis) {
    super.name = inname;
    packet = pack;
    methoden = met;
    attribute = att;
    zusicherung = zu;
    stereotyp = stereo;
    abstrakt = abst;
    visibility = vis;
  }

  public void setPacket(String inpacket) {packet=inpacket;}
  public void setMethoden(Vector meth) {methoden = meth;}
  public void setMethoden(UmlKlassenMethode meth) {methoden.addElement(meth);}
  public void setAttribute(Vector att) {attribute = att;}
  public void setAttribute(UmlKlassenAttribut att) {attribute.addElement(att);}
  public void setZusicherung(String zu) {zusicherung=zu;}
  public void setStereotyp(String st) {stereotyp=st;}
  public void setAbstrakt(boolean abst) {abstrakt=abst;}
  public void setVisibility(int vis) {visibility=vis;}

  public String getPacket() {return packet;}
  public Vector getMethoden() {return methoden;}
  public UmlKlassenMethode getMethoden(int index) {return (UmlKlassenMethode) methoden.elementAt(index);}
  public Vector getAttribute() {return attribute;}
  public UmlKlassenAttribut getAttribute(int index) {return (UmlKlassenAttribut) attribute.elementAt(index);}
  public String getZusicherung() {return zusicherung;}
  public String getStereotyp() {return stereotyp;}
  public int getVisibility() {return visibility;}
  public boolean getAbstrakt() {return abstrakt;}

  public void delAttribut(int index) {attribute.removeElementAt(index);}
  public void delMethode(int index) {attribute.removeElementAt(index);}
  public int getAttributAnzahl() {return attribute.size();}
  public int getMethodenAnzahl() {return methoden.size();}

  public String getString() {
    String klasse="";
    klasse = klasse + "-------------------------------------------------------------------------\n";
    klasse = klasse + packet + ":" + name + "\n" + zusicherung + "\n" + stereotyp + "\n" + abstrakt + "\n" + visibility + "\n";
    klasse = klasse + "-------------------------------------------------------------------------\n";
    for (int i=0;i<methoden.size();i++) {
      klasse = klasse + ((UmlKlassenMethode) methoden.get(i)).getString()+ "\n";
    }
    klasse = klasse + "-------------------------------------------------------------------------\n";
    for (int i=0;i<attribute.size();i++) {
      klasse = klasse + ((UmlKlassenAttribut) attribute.get(i)).getString()+ "\n";
    }
    return klasse;
  }
  public String getKompTyp() {return "UmlKlasse";}

}