package Utopp;

import javax.swing.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import Utopp.Komponenten.*;
import Utopp.Klassen.*;


import java.util.Vector;

class MainKL extends CloseableJFrame implements ActionListener
	{
	static MainKL frame;
        static Dimension dim;
        Container cp;
	static UmlKlasse KL;
        static boolean edited = false;

	MainKL()
		{
                super("UmlKlasse");
                cp = getContentPane();
                cp.setLayout(new FlowLayout());
                JButton Load   = new JButton("Load");
                Load.addActionListener(this);
                JButton Save   = new JButton("Save");
                Save.addActionListener(this);
                JButton Edit   = new JButton("Edit");
                Edit.addActionListener(this);
                JButton New    = new JButton("New");
                New.addActionListener(this);
                JButton Delete = new JButton("Delete");
                Delete.addActionListener(this);
                JButton Quit   = new JButton("Quit");
                Quit.addActionListener(this);
                JButton Show   = new JButton("Show");
                Show.addActionListener(this);
                cp.add(New);
                cp.add(Edit);
                cp.add(Delete);
                cp.add(Show);
                cp.add(Load);
                cp.add(Save);
                cp.add(Quit);
                }

	public void actionPerformed(ActionEvent event)
		{
		String command = event.getActionCommand();
		if (command.equals("Quit"))
			{
			killYourself();
			}
		if (command.equals("Load"))
			{
                        loadInstance();
                        }
		if (command.equals("Save"))
			{
                        saveInstance();
			}
                if (command.equals("Edit"))
                        {
                        editInstance();
                        }
                if (command.equals("New"))
                        {
                        createNewInstance();
                        }
                if (command.equals("Delete"))
                        {
                        deleteInstance();
                        }
                if (command.equals("Show"))
                        {
                        showInstance();
                        }
                }

        private void createNewInstance()
                {
                KL = new UmlKlasse();
                //Finde Namen heraus
//???                String Name = (String)JOptionPane.showInputDialog(frame,"Bitte einen Namen eingeben");
                //erzeuge neue Instanz
//???                KL.setName(Name);
                editInstance();
                edited = true;
                }
        private void editInstance()
                {
                if (KL != null)
                        {

                        EditKLB EditKlasse = new EditKLB(frame,true,KL);
                        EditKlasse.setLocation(((dim.width - 600)/2),((dim.height-500)/2));
                        EditKlasse.setSize(600,500);
                        EditKlasse.setTitle("Klasse Editieren");
                        EditKlasse.setVisible(true);

                        edited = true;
                        }
                }
          private void showInstance()
                {
                if (KL != null)
                        {
                        ShowKL ShowKlasse = new ShowKL(frame,true,KL);
                        ShowKlasse.setLocation(((dim.width - 600)/2),((dim.height-500)/2));
                        ShowKlasse.setSize(600,500);
                        ShowKlasse.setVisible(true);
                        }
                }


        private void loadInstance()
                {
                //Ermittle den Pfad und den Namen des zu ladenen Objekts
                JFileChooser chooser = new JFileChooser();
                chooser.setCurrentDirectory(new File(".\\Utopp"));
                int returnVal = chooser.showOpenDialog(frame);
                if (returnVal == JFileChooser.APPROVE_OPTION)
                        {
                        File Path = chooser.getSelectedFile();
                        //Lade Objekt in den Speicher
                        System.out.println("Lade Objekt : "+Path.toString());
                        //Es braucht nicht gespeichert zu werden
                        edited = false;
                        }
                else
                        {
                        System.out.println("Es wurde abgebrochen");
                        }
                }
        private static void saveInstance()
                {
                if (edited)
                        {
                        //Ermittle den Pfad und den Namen des zu ladenen Objekts
                        JFileChooser chooser = new JFileChooser();
                        chooser.setCurrentDirectory(new File(".\\Utopp"));
                        int returnVal = chooser.showSaveDialog(frame);
                        if (returnVal == JFileChooser.APPROVE_OPTION)
                                {
                                File Path = chooser.getSelectedFile();
                                //Speichere Objekt auf externen Datentrger
                                System.out.println("Speichere Objekt nach : "+Path.toString());
                                try
                                        {
                                        FileOutputStream fs = new FileOutputStream(Path);
                                        ObjectOutputStream os = new ObjectOutputStream(fs);
                                        os.writeObject(KL);
                                        os.close();
                                        }
                                catch (IOException e)
                                        {
                                        System.out.println("Fehler beim Speichern");
                                        }
                                //Es braucht nicht noch einmal gespeichert werden
                                edited = false;
                                }
                        else
                                {
                                System.out.println("Es wurde abgebrochen");
                                }
                        }
                }
        private void deleteInstance()
                {
                KL = null;
                edited = true;
                }
        public static void killYourself()
                {
                //Wurde bereits gespeichert?
                if (edited)
                        {
                        //Frage nach, ob gespeichert werden soll
                        int Auswahl = JOptionPane.showConfirmDialog(frame,"Soll vor dem Beenden das Objekt gespeichert werden?","Achtung",JOptionPane.YES_NO_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE);
                        if (Auswahl == JOptionPane.YES_OPTION)
                                {
                                saveInstance();
                                System.exit(0);
                                }
                        if (Auswahl == JOptionPane.NO_OPTION)
                                {
                                System.exit(0);
                                }
                        if (Auswahl == JOptionPane.CANCEL_OPTION)
                                {
                                }
                        }
                else
                        {
                        System.exit(0);
                        }
                }
/**  public static UmlKlasse getActKlasse() {
    return KL;
  }
*/

	public static void main(String[] args)
		{

		dim = Toolkit.getDefaultToolkit().getScreenSize();
		frame = new MainKL();
		frame.addWindowListener(
				new WindowAdapter()
					{
					public void windowClosed(WindowEvent e)
						{
                                                killYourself();
                                                }
					}
				);
                int paneX = (dim.width - 300) / 2 ;
		int paneY = (dim.height - 100) / 2 ;
		frame.setLocation(paneX,paneY);
		frame.setSize(300,100);
		frame.setVisible(true);
                }
	}