package Utopp.Komponenten;
import java.util.Vector;
/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:
 * @author
 * @version 1.0
 */

public class UmlKlassenMethode implements java.io.Serializable {
String name;
String rckgabewert;
Vector parameter = new Vector();
int visibility;
boolean statisch;

  public UmlKlassenMethode() {}
  public UmlKlassenMethode(String inname, String rck, Vector para, int vis, boolean stat) {
    name = inname;
    rckgabewert = rck;
    parameter = para;
    visibility = vis;
    statisch = stat;
  }

  public void setName(String inname) {name=inname;}
  public void setRckgabewert(String inrck) {rckgabewert=inrck;}
  public void setParameter(Vector para) {parameter = para;}
  public void setParameter(UmlKlassenParameter para) {parameter.addElement(para);}
  public void setVisibility(int vis) {visibility=vis;}
  public void setStatisch(boolean stat) {statisch=stat;}

  public String getName() {return name;}
  public String getRckgabewert() {return rckgabewert;}
  public Vector getParameter() {return parameter;}
  public UmlKlassenParameter getParameter(int index) {return (UmlKlassenParameter) parameter.elementAt(index);}
  public int getVisibility() {return visibility;}
  public boolean getStatisch() {return statisch;}

 	public int getParameterAnzahl() {return parameter.size();}


  public String getString() {
    String para="";
    switch (visibility) {
      case 0: para = "public ";
      case 1: para = "protected ";
      case 2: para = "private ";
    }
    if (statisch) para = para + "static ";
    para = rckgabewert + " " + name + "(";
    for (int i=0;i<parameter.size();i++) {
      para = para + ((UmlKlassenParameter)parameter.get(i)).getString()+ ",";
    }
    para = para + ")";
    return para;
  }
  public String getKompTyp() {return "UmlKlassenMethode";}
}